{
  Snow Fighters
  ==============================================
  (c) 2002 MSX Files
  Programmed by SLotman
  Enjoy this x-mas demo! =)

}

Const Mult16: array[0..32] of integer=
     (0,16,32,48,64,80,96,112,128,144,160,176,192,
      208,224,240,256,272,288,304,320,336,352,368,
      384,400,416,432,448,464,480,496,512);
      
      Mult32: array[0..10] of integer=(0,32,64,96,128,160,192,224,256,288,320);

{ Global variables }
var PlayerX, PlayerY: integer;
    PlayerChar, PlayerAnim: byte;  
    PlayerBalls: integer;
    
    CPUX, CPUY: integer;
    CPUChar, CPUAnim: byte;
    CPUMoveX, CPUMoveY: integer;
    CPUBalls:integer;
    
    CPUBallX, CPUBallY: integer;
    PlayerBallX, PlayerBallY: integer;

    WPage,VPage: byte; { Working and visual pages }
    

{$i misc.inc}
{$i pal.inc }
{$i MsxDskIO.inc}
{$i msx.inc }
{$i sprite.inc}
                         
{ Sprite graphic and colors }                         
Const LineColor : SpriteColorArrayType=(7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7);
      BallColor : SpriteColorArrayType=(15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15);
      Ball      : Sprite8Type=($00,$3c,$7e,$7e,$7e,$7e,$3c,$00);
      BallLine  : Sprite8Type=($3c,$42,$81,$81,$81,$81,$42,$3c);



procedure setgamepal; 
{ set the game palette }
begin
SetRGB(00,7,0,7);
SetRGB(01,0,1,3);
SetRGB(02,2,2,0);
SetRGB(03,5,4,4);
SetRGB(04,0,0,5);
SetRGB(05,0,4,0);
SetRGB(06,7,2,2);
SetRGB(07,0,0,0);
SetRGB(08,4,4,0);
SetRGB(09,4,4,3);
SetRGB(10,6,6,0);
SetRGB(11,7,7,2);
SetRGB(12,4,4,4);
SetRGB(13,6,5,5);
SetRGB(14,6,6,5);
SetRGB(15,7,7,7);
end;                         

procedure settitlepal;  
{ set the title palette }
begin
SetRGB(00,0,0,0);
SetRGB(01,0,0,1);
SetRGB(02,1,1,1);
SetRGB(03,0,0,3);
SetRGB(04,2,2,2);
SetRGB(05,3,3,3);
SetRGB(06,1,1,4);
SetRGB(07,1,1,6);
SetRGB(08,2,2,5);
SetRGB(09,2,2,6);
SetRGB(10,4,4,4);
SetRGB(11,5,5,5);
SetRGB(12,4,4,7);
SetRGB(13,6,6,6);
SetRGB(14,6,6,7);
SetRGB(15,7,7,7);
end;

Procedure selscreenpal;      
{ set the select screen palette }
begin
SetRGB(00,7,0,7);
SetRGB(01,0,1,3);
SetRGB(02,2,2,0);
SetRGB(03,5,4,4);
SetRGB(04,0,0,5);
SetRGB(05,0,4,0);
SetRGB(06,7,2,2);
SetRGB(07,0,0,0);
SetRGB(08,4,4,0);
SetRGB(09,4,4,3);
SetRGB(10,6,6,0);
SetRGB(11,7,7,2);
SetRGB(12,4,4,4);
SetRGB(13,6,5,5);
SetRGB(14,6,6,5);
SetRGB(15,7,7,7);
end;


function Collision(x1,y1,w,h,x2,y2,w2,h2:byte):byte;
{ detect the collision between two rectangles }          
var hit: byte;
begin         
  {
  Collision:=false;
  if (x1<x2+w2) and (x1+w>x2) and (y1<y2+h2) and (y1+h>y2) then Collision:=true;
  }
  INLINE (
$F3/$3E/$00                 (*         LD A,0                              *)
/$32/hit                (*         LD (Collision),A                    *)

/$3A/x2                 (*         LD A,(x2)                           *)
/$47                    (*         LD B,A                              *)
/$3A/w2                 (*         LD A,(w2)                           *)
/$80                    (*         ADD A,B                             *)
/$47                    (*         LD B,A                              *)
/$3A/x1                 (*         LD A,(x1)                           *)
/$B8                    (*         CP B                                *)
/$F2/*+$0031            (*         JP P,FINAL                          *)

/$47                    (*         LD B,A                              *)
/$3A/w                  (*         LD A,(w)                            *)
/$80                    (*         ADD A,B                             *)
/$47                    (*         LD B,A                              *)
/$3A/x2                 (*         LD A,(x2)                           *)
/$B8                    (*         CP B                                *)
/$F2/*+$0024            (*         JP P,FINAL                          *)

/$3A/y2                 (*         LD A,(y2)                         *)
/$47                    (*         LD B,A                              *)
/$3A/h2                 (*         LD A,(h2)                         *)
/$80                    (*         ADD A,B                             *)
/$47                    (*         LD B,A                              *)
/$3A/y1                 (*         LD A,(y1)                         *)
/$B8                    (*         CP B                                *)
/$F2/*+$0014            (*         JP P,FINAL                          *)

/$47                    (*         LD B,A                              *)
/$3A/h                  (*         LD A,(h)                         *)
/$80                    (*         ADD A,B                             *)
/$47                    (*         LD B,A                              *)
/$3A/y2                 (*         LD A,(y2)                         *)
/$B8                    (*         CP B                                *)
/$F2/*+$0007            (*         JP P,FINAL                          *)

/$3E/$01                (*         LD A,1                              *)
/$32/hit                (*         LD (hit),A                         *)

                        (*FINAL                                        *)
/$FB);                  (*         NOP                                 *)
Collision:=hit;
end;


Procedure DrawChar(pchar,anim,PosX,PosY:byte);
{ Draw player or enemy char }
Var CharY,CharX: integer;
begin
  CharY:=Mult32[pchar];
  CharX:=Mult16[anim];
  CopyL_xy(CharX,CharY,2,PosX,PosY,WPage,16,32,tpset,0);

end;                  

Procedure Flip;              
{ show the current working page on screen
  and make the old visual page the current
  working one }
  
var TempPage: byte;
begin              
 
  TempPage:=VPage;
  VPage:=WPage;
  WPage:=TempPage;
  setpage(VPage,WPage);
  
end;


Procedure Clearchar(PC: byte);
{ Clear the old selected char }
begin          
   Case PC of
        0: copy(14,23,89,106,3,14,23,0);
        1: copy(91,23,166,106,3,91,23,0);
        2: copy(168,23,243,106,3,168,23,0);
        3: copy(54,109,129,192,3,54,109,0);
        4: copy(132,109,207,192,3,132,109,0);
   end;
end;

Procedure DrawSelchar(PC: byte);
{ Draws the selected char }
begin          
   Case PC of
        0: copy(14,23,89,106,2,14,23,0);
        1: copy(91,23,166,106,2,91,23,0);
        2: copy(168,23,243,106,2,168,23,0);
        3: copy(54,109,129,192,2,54,109,0);
        4: copy(132,109,207,192,2,132,109,0);
   end;
end;

var ExitTitle, GameOver: boolean;
    S: byte;                
    T: boolean;
    PlayerMoved, CPUMoved: boolean;
    Acertou: boolean;
    fr:integer;               
    Clique:byte;
    c:char;
    
begin          
  { Detect R-800 mode and force Z80 mode if finds it }
  if msx_version>3 then begin
     writeln('MSX Turbo-R detected!');
     writeln('Switching to Z80 mode...');
     switch_to_Z80;
  end;                                           

  { remove the keyboard click }
  if ClickSW>0 then begin Clique:=ClickSW; ClickSW:=0; end;

  { Start screen 5 }
  screen(5);        
  
  { Set sprites }
  enablesprites; spritesize8; ClearAllSprites;
  setspritepattern(0, ball); 
  setspritepattern(1, ballLine); 

  { Ball colors } 
  setspritecolors(0,ballcolor); 
  setspritecolors(1,linecolor);
  setspritecolors(2,ballcolor); 
  setspritecolors(3,linecolor);
  


  ExitTitle:=false;
  { Title screen loop }
  repeat            
     GameOver:=false;
     { Load title and sel.screen graphics }
     LoadGraphic('title.gfx',256,212,0,0,1,0,0,5);
     LoadGraphic('selscr1.gfx',256,212,0,0,2,0,0,5);
     LoadGraphic('selscr2.gfx',256,212,0,0,3,0,0,5);
     
     
     { Copy title to visible screen }
     copy(0,0,255,211,1,0,0,0);
     
     { set the palette }
     settitlepal;              

     { wait for a keypress... }
     repeat
     until keypressed; 
     
     { if ESC pressed, get out of the game }
     if keypressed then begin 
        c:=inkey;
        if c=chr(27) then begin
           GameOver:=true;
           ExitTitle:=true;
        end;   
     end;   
     
     
     if not GameOver then begin
        fadeout;
        copy(0,0,255,211,3,0,0,0);
        PlayerChar:=0;
        DrawSelChar(PlayerChar);     
        selscreenpal;
        
        { select screen loop }
        repeat                       
          S:=stick(0) or stick(1);
          if (s=3) and (PlayerChar<4) then begin
             ClearChar(PlayerChar);
             PlayerChar:=PlayerChar+1;
             DrawSelChar(PlayerChar);
             delay(50);
          end;   
          if (s=7) and (PlayerChar>0) then begin
             ClearChar(PlayerChar);
             PlayerChar:=PlayerChar-1;
             DrawSelChar(PlayerChar);
             delay(50);
          end;   
        until (strig(0) or strig(1));
        fadeout;

        { Load graphic bkg to page 3 }
        LoadGraphic('snow.gfx',256,212,0,0,3,0,0,5);
  
        { Load graphic fighters to page 2 }
        LoadGraphic('fighters.gfx',256,212,0,0,2,0,0,5);
  
        WPage:=1; VPage:=0;
        randomize;
  
        { Set game variables }
        GameOver:=false;
        PlayerX:=10; PlayerY:=150;          
        PlayerAnim:=0;
        PlayerBalls:=1;
        PlayerBallX:=-32; PlayerBallY:=-32;
  
        CPUX:=229; CPUY:=150;
        
        { select who's your enemy }
        for fr:=0 to 100+random(100) do CPUChar:=random(4);
        while CPUChar=PlayerChar do begin
              CPUChar:=random(4); 
        end;                    
        CPUAnim:=4;
        CPUMoveY:=random(100);
        CPUBalls:=1;
        CPUBallX:=-32; CPUBallY:=-32;
        if CPUMoveY>50 then CPUMoveY:=4 else CPUMoveY:=-4;
  
  
        { Draw everything once }

        { Set working and visible page }
        setpage(VPage,WPage);

        { Copy page 3 on working and visual page }
        Copy_xy(0,0,3,0,0,0,256,212,0); 
        Copy_xy(0,0,3,0,0,1,256,212,0); 

        { Draw Chars on working page }
        DrawChar(PlayerChar,PlayerAnim,PlayerX,PlayerY);
        DrawChar(CPUChar,CPUAnim,CPUX,CPUY);
    
        { swap working page with visual page }
        Flip; 
    
        { set the game palette }
        setgamepal;             
     end;
     
     
     { start main game loop }
     while not GameOver do begin 
       PlayerMoved:=false; CPUMoved:=false;
       Acertou:=false;

       { read the cursor/ joystick }
       S:=stick(0) or stick(1); 
       if S<>0 then begin
          { Ok, player moved! } 
          if ((s<3) or (s=8)) and (PlayerY>110) then PlayerY:=PlayerY-4;
          if ((s>3) and (s<7)) and (PlayerY<175) then PlayerY:=PlayerY+4;
          if ((s>1) and (s<5)) and (PlayerX<235) then PlayerX:=PlayerX+4;
          if (s>5) and (PlayerX>3) then PlayerX:=PlayerX-4;
          PlayerMoved:=true;
          PlayerAnim:=PlayerAnim+1;
          if PlayerAnim>1 then PlayerAnim:=0;
       end;                   
               
       { Read triggers }               
       T:=(strig(0) or strig(1));
       if (T) and (PlayerBalls>0) then begin
          PlayerAnim:=2;
          PlayerBallX:=PlayerX+16;
          PlayerBallY:=PlayerY+18;
          PlayerBalls:=0;       
       end;              
       if PlayerBalls=0 then begin
          PlayerBallX:=PlayerBallX+4;
          if PlayerBallX>255 then begin
             PlayerBalls:=1;
             PlayerBallX:=-32;
             PlayerBallY:=-32;
          end else begin
             if Collision(PlayerBallX,PlayerBallY,8,8,CPUX,CPUY,16,32)=1 then begin
                PlayerBallX:=-32; PlayerBallY:=-32;
                CPUBallX:=-32; CPUBallY:=-32;
                CPUAnim:=7;       
                PlayerBalls:=1;
                Acertou:=true;
                CPUMoved:=true;
                putsprite(0,0,PlayerBallX,PlayerBallY);
                putsprite(1,1,PlayerBallX,PlayerBallY);
                  
                putsprite(2,0,CPUBallX,CPUBallY);
                putsprite(3,1,CPUBallX,CPUBallY);
       
                { Make sure the sprites will appear on page 1 }
                { thanks for the tip, Fudeba!                 }
                if (WPage=1) then Copy_y (0,212,0,212,43,1,0);
                
             end;   
          end;
       end;
                       
       CPUMoved:=true;
       if not acertou then begin
          if (random(10)>7) and (CPUBalls>0) then begin
             { CPU shoots! }                
             CPUBalls:=0;
             CPUAnim:=6;             
             CPUBallX:=CPUX;
             CPUBallY:=CPUY+18;
          end else begin
             { CPU walks }
             CPUAnim:=CPUAnim+1;
             if CPUAnim>5 then CPUAnim:=4;                                  
             CPUY:=CPUY+CPUMoveY;
             if (CPUY>175) or (CPUY<114) then CPUMoveY:=-CPUMoveY;
             if CPUBalls=0 then begin
                CPUBallX:=CPUBallX-4;
                if CPUBallX<0 then begin
                   CPUBallX:=-32;
                   CPUBallY:=-32;
                   CPUBalls:=1;
                end else begin
                   if Collision(CPUBallX,CPUBallY,8,8,PlayerX,PlayerY,16,32)=1 then begin
                      PlayerBallX:=-32; PlayerBallY:=-32;
                      CPUBallX:=-32; CPUBallY:=-32;
                      CPUBalls:=1;
                      PlayerAnim:=3;
                      Acertou:=true;
                      PlayerMoved:=true;
                      putsprite(0,0,PlayerBallX,PlayerBallY);
                      putsprite(1,1,PlayerBallX,PlayerBallY);
                  
                      putsprite(2,0,CPUBallX,CPUBallY);
                      putsprite(3,1,CPUBallX,CPUBallY);
       
                      { Make sure the sprites will appear on page 1 }
                      { thanks for the tip, Fudeba!                 }
                      if (WPage=1) then Copy_y (0,212,0,212,43,1,0);
                   end;
                end;   
             end;   
          end;      
       end;                      
    
       If (CPUBalls=0) and (PlayerBalls=0) then begin
          if Collision(PlayerBallX,PlayerBallY,8,8,CPUBallX,CPUBallY,8,8)=1 then begin
             PlayerBallX:=-32; PlayerBallY:=-32;
             CPUBallX:=-32; CPUBallY:=-32;
             PlayerBalls:=1;
             CPUBalls:=1;          
          end;                            
       end;
                 
       if acertou then begin
          PlayerBallX:=-32; PlayerBallY:=-32;
          CPUBallX:=-32; CPUBallY:=-32;   
          for fr:=0 to 3 do putsprite(fr,0,-32,-32);
       end else begin 
           { Draw snow balls }      
           putsprite(0,0,PlayerBallX,PlayerBallY);
           putsprite(1,1,PlayerBallX,PlayerBallY);
                  
           putsprite(2,0,CPUBallX,CPUBallY);
           putsprite(3,1,CPUBallX,CPUBallY);
       end;             
    
       
       { Make sure the sprites will appear on page 1 }
       { thanks for the tip, Fudeba!                 }
       if (WPage=1) then Copy_y (0,212,0,212,43,1,0);
       
       if PlayerMoved or CPUMoved then begin
          { Redraw everything from y=110 to y=211 }
          {Copy_xy(0,110,3,0,110,WPage,256,102,0);}
          Copy_y (0,110,3,110,101,WPage,0);
       
          DrawChar(PlayerChar,PlayerAnim,PlayerX,PlayerY);
          DrawChar(CPUChar,CPUAnim,CPUX,CPUY);
          { Show }
          Flip;
       end;            

       if acertou then begin
          delay(1000);
          PlayerX:=10; PlayerY:=150;          
          PlayerAnim:=0;
          PlayerBalls:=1;
          PlayerBallX:=-32; PlayerBallY:=-32;
  
          CPUX:=229; CPUY:=150;
          CPUAnim:=4;
          CPUMoveY:=random(100);
          CPUBalls:=1;
          CPUBallX:=-32; CPUBallY:=-32;
          if CPUMoveY>50 then CPUMoveY:=4 else CPUMoveY:=-4;
       end;   
       if keypressed then begin 
          c:=inkey;
          if c=chr(27) then GameOver:=true;
       end;
     end; { GameOver; }     
     fadeout;

     { remove sprites from screen }
     for fr:=0 to 3 do putsprite(fr,0,-32,-32);
  until ExitTitle;

  { reset palette and go back to screen 0 }
  color(15,0,0); inipalette; screen(0); 
  { put the keyboard click as it was before the }
  { game started                                }
  ClickSW:=Clique;
end.
